| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Attributes | List of all members
Ogre::RTShader::FFPColour Class Reference
Optional Components » RTShaderSystem

Colour sub render state implementation of the Fixed Function Pipeline. More...

`#include <OgreShaderFFPColour.h>`

Inheritance diagram for Ogre::RTShader::FFPColour:
[legend]

## Public Types
enum | StageFlags { SF_VS_INPUT_DIFFUSE = 1 << 1, SF_VS_INPUT_SPECULAR = 1 << 2, SF_VS_OUTPUT_DIFFUSE = 1 << 3, SF_VS_OUTPUT_SPECULAR = 1 << 4, SF_PS_INPUT_DIFFUSE = 1 << 5, SF_PS_INPUT_SPECULAR = 1 << 6, SF_PS_OUTPUT_DIFFUSE = 1 << 7, SF_PS_OUTPUT_SPECULAR = 1 << 8 }

## Public Member Functions
| FFPColour ()
| Class default constructor. More...
void | addResolveStageMask (unsigned int mask)
| Add the given mask to resolve stage flags that this sub render state will produce. More...
virtual void | copyFrom (const SubRenderState &rhs)
| More...
virtual bool | createCpuSubPrograms (ProgramSet *programSet)
| Create sub programs that represents this sub render state as part of a program set. More...
SubRenderStateAccessorPtr | getAccessor ()
| Return the accessor object to this sub render state. More...
SubRenderStateAccessorPtr | getAccessor () const
| Return the accessor object to this sub render state. More...
virtual int | getExecutionOrder () const
| More...
unsigned int | getResolveStageFlags () const
| Get the current resolve stage flags. More...
virtual const String & | getType () const
| More...
virtual bool | preAddToRenderState (const RenderState *renderState, Pass *srcPass, Pass *dstPass)
| More...
void | removeResolveStageMask (unsigned int mask)
| Remove the given mask from the resolve stage flags that this sub render state will produce. More...
void | setResolveStageFlags (unsigned int flags)
| Set the resolve stage flags that this sub render state will produce. More...
virtual void | updateGpuProgramsParams (Renderable *rend, Pass *pass, const AutoParamDataSource *source, const LightList *pLightList)
| Update GPU programs parameters before a rendering operation occurs. More...

## Static Public Attributes
static String | Type

## Detailed Description

Colour sub render state implementation of the Fixed Function Pipeline.

Derives from SubRenderState class.

## Member Enumeration Documentation

## ◆ StageFlags

enum Ogre::RTShader::FFPColour::StageFlags

Enumerator
SF_VS_INPUT_DIFFUSE |
SF_VS_INPUT_SPECULAR |
SF_VS_OUTPUT_DIFFUSE |
SF_VS_OUTPUT_SPECULAR |
SF_PS_INPUT_DIFFUSE |
SF_PS_INPUT_SPECULAR |
SF_PS_OUTPUT_DIFFUSE |
SF_PS_OUTPUT_SPECULAR |

## Constructor & Destructor Documentation

## ◆ FFPColour()

Ogre::RTShader::FFPColour::FFPColour | ( |  | ) |

Class default constructor.

## Member Function Documentation

## ◆ getType()

virtual const String& Ogre::RTShader::FFPColour::getType | ( |  | ) | const
| virtual

See also
  SubRenderState::getType.

Implements Ogre::RTShader::SubRenderState.

## ◆ getExecutionOrder()

virtual int Ogre::RTShader::FFPColour::getExecutionOrder | ( |  | ) | const
| virtual

See also
  SubRenderState::getType.

Implements Ogre::RTShader::SubRenderState.

## ◆ copyFrom()

virtual void Ogre::RTShader::FFPColour::copyFrom | ( | const SubRenderState & | rhs | ) |
| virtual

See also
  SubRenderState::copyFrom.

Implements Ogre::RTShader::SubRenderState.

## ◆ preAddToRenderState()

virtual bool Ogre::RTShader::FFPColour::preAddToRenderState | ( | const RenderState * | renderState,
|  | Pass * | srcPass,
|  | Pass * | dstPass
| ) |  |
| virtual

See also
  SubRenderState::preAddToRenderState.

Reimplemented from Ogre::RTShader::SubRenderState.

## ◆ setResolveStageFlags()

void Ogre::RTShader::FFPColour::setResolveStageFlags | ( | unsigned int | flags | ) |
| inline

Set the resolve stage flags that this sub render state will produce.

I.E - If one want to specify that the vertex shader program needs to get a diffuse component and the pixel shader should output diffuse component he should pass SF_VS_INPUT_DIFFUSE | SF_PS_OUTPUT_DIFFUSE.

Parameters

  flags | The stage flag to set.

## ◆ getResolveStageFlags()

unsigned int Ogre::RTShader::FFPColour::getResolveStageFlags | ( |  | ) | const
| inline

Get the current resolve stage flags.

## ◆ addResolveStageMask()

void Ogre::RTShader::FFPColour::addResolveStageMask | ( | unsigned int | mask | ) |
| inline

Add the given mask to resolve stage flags that this sub render state will produce.

Parameters

  mask | The mask to add to current flag set.

## ◆ removeResolveStageMask()

void Ogre::RTShader::FFPColour::removeResolveStageMask | ( | unsigned int | mask | ) |
| inline

Remove the given mask from the resolve stage flags that this sub render state will produce.

Parameters

  mask | The mask to remove from current flag set.

## ◆ createCpuSubPrograms()

virtual bool Ogre::RTShader::SubRenderState::createCpuSubPrograms | ( | ProgramSet * | programSet | ) |
| virtual inherited

Create sub programs that represents this sub render state as part of a program set.

The given program set contains CPU programs that represents a vertex shader and pixel shader. One should use these program class API to create a representation of the sub state he wished to implement.

Parameters

  programSet | container class of CPU and GPU programs that this sub state will affect on.

Reimplemented in Ogre::RTShader::FFPTransform.

## ◆ updateGpuProgramsParams()

virtual void Ogre::RTShader::SubRenderState::updateGpuProgramsParams | ( | Renderable * | rend,
|  | Pass * | pass,
|  | const AutoParamDataSource * | source,
|  | const LightList * | pLightList
| ) |  |
| inline virtual inherited

Update GPU programs parameters before a rendering operation occurs.

This method is called in the context of SceneManager::renderSingle object via the RenderObjectListener interface and lets this sub render state instance opportunity to update custom GPU program parameters before the rendering action occurs.

See also
  RenderObjectListener::notifyRenderSingleObject.

Parameters

  rend | The renderable that is about to be rendered.
  pass | The pass that used for this rendering.
  source | The auto parameter source.
  pLightList | The light list used in the current rendering context.

Reimplemented in Ogre::RTShader::TriplanarTexturing, Ogre::RTShader::TextureAtlasSampler, Ogre::RTShader::FFPAlphaTest, Ogre::RTShader::PerPixelLighting, Ogre::RTShader::FFPFog, Ogre::RTShader::IntegratedPSSM3, Ogre::RTShader::FFPTexturing, Ogre::RTShader::FFPLighting, and Ogre::RTShader::NormalMapLighting.

## ◆ getAccessor() [1/2]

SubRenderStateAccessorPtr Ogre::RTShader::SubRenderState::getAccessor | ( |  | ) |
| inherited

Return the accessor object to this sub render state.

See also
  SubRenderStateAccessor.

## ◆ getAccessor() [2/2]

SubRenderStateAccessorPtr Ogre::RTShader::SubRenderState::getAccessor | ( |  | ) | const
| inherited

Return the accessor object to this sub render state.

See also
  SubRenderStateAccessor.

## Member Data Documentation

## ◆ Type

String Ogre::RTShader::FFPColour::Type
| static

The documentation for this class was generated from the following file:

- OgreShaderFFPColour.h